#declare GGreen = 
texture {
	pigment {
	        bozo 
	        color_map {
			[0.0 color rgbt <0.55,0.68,0.26,0.1>] 
			[0.5 color rgbt <0.42,0.72,0.17,0.1>] 
			[1.0 color rgbt <0.55,0.68,0.26,0.1>]
		}
	}
	finish {ambient 0 diffuse 0.3 specular 300 roughness 0.01}
}

#declare GTan = 
texture {
	pigment {color rgbt <0.69,0.76,0.36,0.1> }
	finish {ambient 0 diffuse 0.3 specular 300 roughness 0.01}
}

#declare BladeShape = 
intersection {
	sphere {<0,0,0>,20 translate <-4,0,0> inverse}
	sphere {<0,0,0>,20 translate <0,-11.5,0>}
	sphere {<0,0,0>,20 translate <0,11.5,0>}
	clipped_by {
		sphere {<20,0,0>,10 scale <1,1,2> translate <0,0,20>}
        }
	translate <-16.5,0,-1.2>
	scale <1.2,0.2,1> 
	rotate z*180
}

#declare ThinBlade = object {BladeShape texture {GGreen}}

#declare ThinStalk = 
torus {
	36,0.07
	texture {GTan}
	clipped_by {
	        box {<30,-0.5,0>,<37,0.5,14>}
	}
	translate <-36,0,0> 
	rotate z*180
}

#declare SeedHuskShape = 
intersection {
	sphere {<0,0,0.05>,0.05 scale <1,1,8>}
	box {<0.02,-0.1,0>,<1,0.1,1> rotate <0,10,0> inverse}
}
		
#declare SeedAssy = 
union {
	cylinder {<0,0,0>,<0,0,0.2>,0.01} 
	sphere {<0,0,0.2>,0.015}
	object {SeedHuskShape translate z*0.2}
	object {SeedHuskShape rotate z*180 translate z*0.2}
	texture {GTan}
}
		
#declare WS = seed(65709); 
#declare WeedTop = 
union {
	cone {0,0.07,<0,0,8>,0.01 texture {GTan}} 
	#declare SeedCount = 0;
	#while (SeedCount < 50)
		object {SeedAssy
			rotate <rand(WS)*10,rand(WS)*20+5,rand(WS)*360>
			translate <0,0,rand(WS)*6+2>}
		#declare SeedCount = SeedCount+1;
	#end
}

#declare veg32 =
union { 
        object {ThinStalk scale <1,1,0.7> translate <0.3,0,0> rotate <0,-9,0> scale 0.1 rotate x*-90}
	object {WeedTop rotate <0,24,0> translate <1.55,0,10.2> scale 0.1 rotate x*-90}
}
